<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 9548f1f81a43 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-07-02 12:51 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_base_mainmodel{
	/** @var string */
	public $ContentType = ''; //For backup

//Leave this class empty! It is temporary for class compatibility to 	we_contents_base and we_base_model

	public function getLogString(string $prefix = ''): string{
		return '';
	}

	abstract public function save(bool $force = true): bool;

	public function toXML(array $attribs = [], array $extraSlots = [], string $content = ''): string{
		assert($this instanceof we_exim_xmlIF);
		$tagName = we_exim_contentProvider::getTagName($this);
		$ret = '<' . $tagName . ($attribs ? we_xml_composer::buildAttributesFromArray($attribs) : '') . '>';

		foreach(array_keys($this->getPersistent()) as $k){
			'@phan-var string $k';
			if(in_array($k, we_exim_contentProvider::DONT_IMEXPORT_PROPS, true)){
				continue;
			}
			$content = ($this->$k ?? '');
			[$content, $coding] = we_exim_contentProvider::formatXMLData($content);
			$ret .= we_xml_composer::we_xmlElement($k, (string) $content, $coding);
		}

		return $ret . $content . '</' . $tagName . '>';
	}

}
