<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: af87aa135b22 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2021-03-25 09:29 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_doctype_tree extends we_tree_base{

	protected function customJSFile(): string{
		return we_html_element::jsScript(WE_JS_MODULES_DIR . 'mod_tree.js', "initTree('" . we_modules_info::DOCTYPE . "',0);");
	}

	/**
	 *
	 * @param int $ParentID
	 * @param int $offset
	 * @param int $segment @unused-param
	 * @param bool $sort @unused-param
	 * @return array<int,array{id:int,parentid:int,text:string,typ:'group'|'item',open:bool,isfolder:bool,disabled:bool,tooltip:string,offset:int,contenttype:'folder'|'we/doctype',published:bool,table:string}>
	 */
	public static function getItems(int $ParentID, int $offset = 0, int $segment = 500, bool $sort = false): array{
		$items = [];
		$dtq = we_doctype_docTypes::getDoctypeQuery(true);
		foreach(DB_WE::$inst->getAllq('SELECT dt.ID,dt.Text,dt.ParentID,dt.IsFolder FROM ' . DOC_TYPES_TABLE . ' dt LEFT JOIN ' . FILE_TABLE . ' dtf ON dt.ParentFileID=dtf.ID ' . $dtq['join'] . ' WHERE ' . $dtq['where'] . ' AND dt.ParentID=' . $ParentID) as $item){
			$items[] = [
				'id' => (int) $item['ID'],
				'parentid' => (int) $item['ParentID'],
				'text' => addslashes($item['Text']),
				'typ' => $item['IsFolder'] ? self::TYP_FOLDER : self::TYP_ITEM,
				'isfolder' => (bool) $item['IsFolder'],
				'open' => false,
				'disabled' => false,
				'tooltip' => (string) $item['ID'],
				'offset' => $offset,
				'contenttype' => ($item['IsFolder'] ? we_base_ContentTypes::FOLDER_COMMON : we_base_ContentTypes::DOCTYPE),
				'published' => true,
				'table' => DOC_TYPES_TABLE
			];
		}
		return $items;
	}

}
