<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: ac7c44c87b87 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2021-05-19 13:23 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_versions extends we_editor_base{

	public function show(): string{
		assert($this->we_doc instanceof we_document_base);
		$versionsView = new we_versions_view($this->we_doc->versionsModel);
		$content = $versionsView->tblList(); //must be set here, since founditems is computed here

		return $this->getPage($versionsView->getHTMLforVersions([
					we_html_element::div(['id' => 'searchTable'], $versionsView->getBodyTop()),
					we_html_element::div(['id' => 'parametersTop'], $versionsView->getParameterTop()) . $content . we_html_element::div(['id' => 'parametersBottom'], $versionsView->getParameterBottom())
				]), $versionsView->getJS() .
				we_html_element::cssLink(CSS_DIR . 'we_versions.css', ['media' => 'screen']) .
				we_html_element::cssLink(CSS_DIR . 'we_versions_print.css', ['media' => 'print']), [
				'onkeydown' => "javascript:if (event.keyCode === 'Enter'){search(true);}",
				'onload' => "init();",
				'onresize' => "sizeScrollContent();"
		]);
	}

}
