<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: aacab26fe68a $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-05-05 10:25 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_exim_element extends we_base_mainmodel{
	public const BACKUP_XML_TAG = 'we:content';

	/** @var int */
	var $ID = 0;

	/** @var int */
	var $DID = 0;

	/** @var string */
	var $Name = '';

	/** @var string */
	var $nHash = '';

	/** @var string */
	var $Type = '';

	/** @var ?int */
	var $BDID = null;

	/** @var ?string */
	var $Dat = null;

	/** @var int */
	var $LangugeID = 0;

	/** @var int */
	var $Len = 0;

	/** @var array<string,string> */
	var $persistent_slots = [];

	/** @var we_base_model */
	var $Content;

	/** @var we_database_base */
	private static $db;

	public function __construct(array $options = []){
		if(!is_object(self::$db)){
			self::$db = new DB_WE();
		}

		$this->Content = new we_base_model(CONTENT_TABLE, self::$db);
		$this->fetchOptions($options);
		//$this->nHash = md5($this->Name);
		$this->persistent_slots = array_combine(array_keys($options), array_fill(0, count($options), we_base_request::STRING));
	}

	private function fetchOptions(array $options = []): void{
		foreach($options as $k => $v){
			if(property_exists($this, $k)){
				$this->{$k} = $v;
			}
		}
	}

	public function save(bool $force = true, bool $skipHook = false): bool{
		return $this->Content->save();
	}

	function load(): bool{
		t_e('FIXME: called, why, where, fix this');
		if($this->Content->load($this->ID)){
			return true;
		}
		return false;
	}

	function getElement(): array{
		return [
			$this->Name => [
				'dat' => $this->Dat,
				'bdid' => $this->BDID,
				'type' => $this->Type,
				'len' => $this->Len
			]
		];
	}

}
