<?php

declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 54ba44808c6d $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2020-12-15 12:50 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_rpcCmd_widget extends we_rpc_cmd{

	function execute(): we_rpc_response{
		//FIXME: this needs change, it is only a copy of widget_cmd

		$cmd2 = we_base_request::string('we_cmd', '', 2);
		switch(we_base_request::string('we_cmd', '', 1)){
			case 'save' :
				we_base_preferences::setUserPref('cockpit_dat', $cmd2);
				we_base_preferences::setUserPref('cockpit_rss', we_base_request::string('we_cmd', '', 3));
				break;
			case 'reload':
				//$mod = we_base_request::string('mod');
				/* array_shift($_REQUEST['we_cmd']);
				  array_shift($_REQUEST['we_cmd']);
				 */
				//FIXME: there is nothing done?!
				break;
			case 'add' :
				$newSCurrId = we_base_request::string('we_cmd', '', 3);
				$className = 'we_widget_' . $cmd2;
				$cfg = $className::getDefaultConfig();
				if(!$cfg){
					break;
				}
				$aProps = [
					$cmd2,
					$cfg['cls'],
					$cfg['res'],
					$cfg['csv'],
				];
				$aCfgProps = we_gui_cockpit::getDefaultCockpit();
				foreach($aCfgProps as $a){
					foreach($a as $arr){
						if($arr[0] == $aProps[0]){
							$aProps[3] = $arr[3];
							break 2;
						}
					}
				}
				$iCurrId = str_replace('m_', '', $newSCurrId);
				$className = 'we_widget_' . $aProps[0];
				try{
					$widgetInst = new $className($iCurrId);
					[$oTblDiv, $aLang] = $widgetInst->getInsertDiv($iCurrId, $aProps);

					echo we_html_tools::getHtmlTop('', we_html_element::cssElement('div,span{display:none;}') . we_html_element::jsScript(JS_DIR . 'home.js'), we_html_element::body(
									['onload' => "WE().layout.cockpitFrame.transmit(window,'" . $aProps[0] . "','m_" . $iCurrId . "');"
									], we_html_element::div(['id' => 'content'], $oTblDiv) .
									we_html_element::span(['id' => 'prefix'], $aLang[0]) .
									we_html_element::span(['id' => 'postfix'], $aLang[1]) .
									we_html_element::span(['id' => 'csv'], ($aProps[3] ?? '')))
					);
				}catch(we_exception_permission | we_exception_widget $e){

				}
				break;

			//added to fix bug #6538
			case 'reset_home':
				$id = we_users_user::getID();
				//delete user's cockpit preferences from db
				DB_WE::$inst->query('REPLACE INTO ' . PREFS_TABLE . ' (`userID`,`key`,`value`) VALUES (' . $id . ',"cockpit_dat",""),(' . $id . ',"cockpit_amount_columns",""),(' . $id . ',"cockpit_rss","")');
				we_gui_cockpit::getEditor();
				break;
		}

		return $this->resp;
	}

}
