<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: 6eb363c8b017 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2020-11-25 12:06 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

//FIXME:remove in cardada
abstract class we_tag_linklist extends we_weTag_tag{

	public static function parse(array $attribs, string $content): string{
		return '<?php ' . we_weTag_parser::printTag('linklist', $attribs) . ';?>' .
			we_tag_block::parse($attribs, $content);
	}

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): void{
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		self::$doc = we_base_WE::getWeDoc();
		if(we_base_WE::$editmode){
			echo htmlspecialchars('remove <we:linklist> and replace it with: <we:block name="' . $name . '"><we:link name="link"></we:block>');
		}
		if(self::$doc->getElementType($name) === 'block'){
			return;
		}
		$tmp = we_unserialize(self::$doc->getElementS($name));
		$new = [];
		foreach($tmp as $i => $cur){
			$i = '_' . ($i + 1);
			$new[] = $i;
			self::$doc->setElementS('linkblk_' . $name . '_' . $i, $cur, 'block');
		}
		self::$doc->setElementS($name, we_serialize($new));
	}

}
