<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: e9fb15a2aaef $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-11-15 17:36 +0100 $
 */
class we_tw_include extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);
		$this->NeedsEndTag = false;

		$included = new we_weTag_selectAttribute($this, 'included', '', [], false, '');
		$id = new we_weTag_selectorAttribute($this, 'id', '', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT, false, '');
		$path = new we_weTag_selectorAttribute($this, 'path', '', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT, false, '', true);
//$path = new weTagData_textAttribute('path', false, '');
		$gethttp = new we_weTag_selectAttribute($this, 'gethttp', '', we_weTag_selectAttribute::getTrueFalse());
		$seeMode = new we_weTag_selectAttribute($this, 'seeMode', '', we_weTag_selectAttribute::getTrueFalse());
		$once = new we_weTag_selectAttribute($this, 'once', '', we_weTag_selectAttribute::getTrueFalse());
		$merge = new we_weTag_selectAttribute($this, 'merge', '', we_weTag_selectAttribute::getTrueFalse());
		$kind = new we_weTag_selectAttribute($this, 'kind', '', [
			new we_weTag_option('all', false, ''),
			new we_weTag_option('int', false, ''),
			new we_weTag_option('ext', false, '')
			], false, '');
		$name = new we_weTag_textAttribute($this, 'name', '', false, '');
		$description = new we_weTag_textAttribute($this, 'description', '', false, '');
		$id_temp = new we_weTag_selectorAttribute($this, 'id', '', TEMPLATES_TABLE, we_base_ContentTypes::TEMPLATE, false, '');
		$path_temp = new we_weTag_selectorAttribute($this, 'path', '', TEMPLATES_TABLE, we_base_ContentTypes::TEMPLATE, false, '', true);
		$rootdir = new we_weTag_selectorAttribute($this, 'rootdir', '', FILE_TABLE, we_weTag_selectorAttribute::FOLDER, false, '', true);
		$startid = new we_weTag_selectorAttribute($this, 'startid', '', FILE_TABLE, we_weTag_selectorAttribute::FOLDER, false, '');

		$this->TypeAttribute = new we_weTag_typeAttribute($this, 'type', [
			new we_weTag_option('document', false, '', [$id, $path, $gethttp, $seeMode, $kind, $name, $rootdir, $startid, $description, $merge], []),
			new we_weTag_option('template', false, '', [$path_temp, $id_temp, $once], [])], false, '');

		$this->Attributes = [$included, $id, $path, $path_temp, $gethttp, $seeMode, $kind, $name, $id_temp, $once, $rootdir, $startid, $description];
	}

}
