<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: e9fb15a2aaef $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-11-15 17:36 +0100 $
 */
class we_tw_sessionField extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);
		$this->NeedsEndTag = false;
		$this->Module = we_modules_info::CUSTOMER;
		$name = new we_weTag_sqlColAttribute($this, 'name', '', CUSTOMER_TABLE, true, [], we_modules_info::CUSTOMER);
		$size = new we_weTag_textAttribute($this, 'size', '', false, '', '', 'number');
		$maxlength = new we_weTag_textAttribute($this, 'maxlength', '', false, '', '', 'number');
		$rows = new we_weTag_textAttribute($this, 'rows', '', false, '', '', 'number');
		$cols = new we_weTag_textAttribute($this, 'cols', '', false, '', '', 'number');
		$onchange = new we_weTag_textAttribute($this, 'onchange', '');
		$choice = new we_weTag_choiceAttribute($this, 'choice', '', we_weTag_selectAttribute::getTrueFalse(), false, false);
		$checked = new we_weTag_choiceAttribute($this, 'checked', '', we_weTag_selectAttribute::getTrueFalse(), false, false);
		$value = new we_weTag_textAttribute($this, 'value', '');
		$values = new we_weTag_textAttribute($this, 'values', '');
		$dateformat = new we_weTag_textAttribute($this, 'dateformat', '');
		$id = new we_weTag_textAttribute($this, 'id', '', false, '', '', 'number');
		$removefirstparagraph = new we_weTag_selectAttribute($this, 'removefirstparagraph', '', we_weTag_selectAttribute::getTrueFalse());
		$autofill = new we_weTag_selectAttribute($this, 'autofill', '', we_weTag_selectAttribute::getTrueFalse());
		$parentid = new we_weTag_selectorAttribute($this, 'parentid', '', FILE_TABLE, we_weTag_selectorAttribute::FOLDER);
		$width = new we_weTag_textAttribute($this, 'width', '', false, '', '', 'number');
		$height = new we_weTag_textAttribute($this, 'height', '', false, '', '', 'number');
		$quality = new we_weTag_selectAttribute($this, 'quality', '', [
			new we_weTag_option('0'),
			new we_weTag_option('1'),
			new we_weTag_option('2'),
			new we_weTag_option('3'),
			new we_weTag_option('4'),
			new we_weTag_option('5'),
			new we_weTag_option('6'),
			new we_weTag_option('7'),
			new we_weTag_option('8'),
			new we_weTag_option('9'),
			new we_weTag_option('10'),
		]);
		$keepratio = new we_weTag_selectAttribute($this, 'keepratio', '', we_weTag_selectAttribute::getTrueFalse());
		$maximize = new we_weTag_selectAttribute($this, 'maximize', '', we_weTag_selectAttribute::getTrueFalse());
		$bordercolor = new we_weTag_textAttribute($this, 'bordercolor', '');
		$checkboxstyle = new we_weTag_textAttribute($this, 'checkboxstyle', '');
		$inputstyle = new we_weTag_textAttribute($this, 'inputstyle', '');
		$checkboxclass = new we_weTag_textAttribute($this, 'checkboxclass', '');
		$inputclass = new we_weTag_textAttribute($this, 'inputclass', '');
		$checkboxtext = new we_weTag_textAttribute($this, 'checkboxtext', '');
		$showcontrol = new we_weTag_selectAttribute($this, 'showcontrol', '', we_weTag_selectAttribute::getTrueFalse());
		$thumbnail = new we_weTag_sqlRowAttribute($this, 'thumbnail', '', THUMBNAILS_TABLE, false, 'Text');
		$thumbid = new we_weTag_sqlRowAttribute($this, 'thumbnailid', '', THUMBNAILS_TABLE, false, 'ID', 'Text', 'Text');
		$ascountry = new we_weTag_selectAttribute($this, 'ascountry', '', we_weTag_selectAttribute::getTrueFalse());
		$aslanguage = new we_weTag_selectAttribute($this, 'aslanguage', '', we_weTag_selectAttribute::getTrueFalse());
		$outputlanguage = new we_weTag_textAttribute($this, 'outputlanguage', '');
		$languageautofill = new we_weTag_selectAttribute($this, 'languageautofill', '', we_weTag_selectAttribute::getTrueFalse());
		$doc = new we_weTag_selectAttribute($this, 'doc', '', [
			new we_weTag_option('self'),
			new we_weTag_option('top'),
		]);

		$usevalue = new we_weTag_selectAttribute($this, 'usevalue', '', we_weTag_selectAttribute::getTrueFalse());
		$minyear = new we_weTag_textAttribute($this, 'minyear', '', false, '', '', 'number');
		$maxyear = new we_weTag_textAttribute($this, 'maxyear', '', false, '', '', 'number');
		$pure = new we_weTag_selectAttribute($this, 'pure', '', we_weTag_selectAttribute::getTrueFalse());
		$wysiwyg = new we_weTag_selectAttribute($this, 'wysiwyg', '', we_weTag_selectAttribute::getTrueFalse(), true);
		//$autobr = new we_weTag_selectAttribute($this, 'autobr', '', we_weTag_selectAttribute::getTrueFalse());
		$html = new we_weTag_selectAttribute($this, 'html', '', we_weTag_selectAttribute::getTrueFalse());
		$htmlspecialchars = new we_weTag_selectAttribute($this, 'htmlspecialchars', '', we_weTag_selectAttribute::getTrueFalse());
		$abbr = new we_weTag_selectAttribute($this, 'abbr', '', we_weTag_selectAttribute::getTrueFalse());
		$commands = new we_weTag_choiceAttribute($this, 'commands', '', we_wysiwyg_editor::getEditorCommands(true), false, true, '');

		$this->TypeAttribute = new we_weTag_typeAttribute($this, 'type', [
			new we_weTag_option('textinput', false, '', [$name, $size, $maxlength, $value], [$name]),
			new we_weTag_option('textarea', false, '', [$name, $rows, $cols, $value, $pure, $wysiwyg, /* $autobr, */ $html, $htmlspecialchars, $abbr, $commands], [$name]),
			new we_weTag_option('checkbox', false, '', [$name, $checked], [$name]),
			new we_weTag_option('radio', false, '', [$name, $checked, $value], [$name]),
			new we_weTag_option('password', false, '', [$name, $size, $maxlength, $value], [$name]),
			new we_weTag_option('hidden', false, '', [$name, $value, $autofill, $languageautofill, $doc, $usevalue, $htmlspecialchars], [$name]),
			new we_weTag_option('print', false, '', [$name, $dateformat, $ascountry, $aslanguage, $outputlanguage, $doc, $htmlspecialchars], [$name]),
			new we_weTag_option('select', false, '', [$name, $size, $value, $values], [$name]),
			new we_weTag_option('choice', false, '', [$name, $size, $maxlength, $value, $values], [$name]),
			new we_weTag_option('img', false, '', [$name, $value, $id, $parentid, $width, $height, $quality, $keepratio, $maximize, $bordercolor, $checkboxstyle,
				$inputstyle, $checkboxclass, $inputclass, $checkboxtext, $showcontrol, $thumbnail, $thumbid], [$name, $parentid]),
			new we_weTag_option('date', false, '', [$name, $dateformat, $minyear, $maxyear, $value], [$name]),
			new we_weTag_option('country', false, '', [$name, $size, $doc, $value], [$name]),
			new we_weTag_option('language', false, '', [$name, $size, $doc, $value], [$name])], true);

		$this->Attributes = [
			$name,
			$size,
			$maxlength,
			$rows,
			$cols,
			$onchange,
			$choice,
			$checked,
			$value,
			$values,
			$dateformat,
			$id,
			$removefirstparagraph,
			$autofill,
			$parentid,
			$width,
			$height,
			$quality,
			$keepratio,
			$maximize,
			$bordercolor,
			$checkboxstyle,
			$inputstyle,
			$checkboxclass,
			$inputclass,
			$checkboxtext,
			$showcontrol,
			$thumbnail,
			$ascountry,
			$aslanguage,
			$outputlanguage,
			$languageautofill,
			$doc,
			$usevalue,
			$minyear,
			$maxyear,
			$pure,
			$wysiwyg,
			$html,
			$htmlspecialchars,
			$abbr,
			$commands,
		];
	}

}
