<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: 56f9b00af49b $
 * $Author: Lukas Imhof $
 * $Date: 2021-09-13 17:58 +0200 $
 */
class we_tw_subscribe extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);
		$this->NeedsEndTag = false;
		$this->Module = we_modules_info::NEWSLETTER;

		$size = new we_weTag_textAttribute($this, 'size', '', false, '', '', 'number');
		$maxlength = new we_weTag_textAttribute($this, 'maxlength', '', false, '', '', 'number');
		$value = new we_weTag_textAttribute($this, 'value', '', false, '');
		$values = new we_weTag_textAttribute($this, 'values', '', false, '');
		$class = new we_weTag_textAttribute($this, 'class', '', false, '');
		$style = new we_weTag_textAttribute($this, 'style', '', false, '');
		$onchange = new we_weTag_textAttribute($this, 'onchange', '', false, '');
		$checked = new we_weTag_selectAttribute($this, 'checked', '', we_weTag_selectAttribute::getTrueFalse());

		$this->TypeAttribute = new we_weTag_typeAttribute($this, 'type', [
			new we_weTag_option('email', false, '', [$size, $maxlength, $value, $class, $style, $onchange], [
				]),
			new we_weTag_option('firstname', false, '', [$size, $maxlength, $value, $class, $style, $onchange], []),
			new we_weTag_option('lastname', false, '', [$size, $maxlength, $value, $class, $style, $onchange], []),
			new we_weTag_option('salutation', false, '', [$size, $maxlength, $value, $values, $class, $style, $onchange], []),
			new we_weTag_option('title', false, '', [$size, $maxlength, $value, $values, $class, $style, $onchange], []),
			new we_weTag_option('listCheckbox', false, '', [$class, $style, $checked], []),
			new we_weTag_option('listSelect', false, '', [$size, $values, $class, $style], [])], false, '');

		$this->Attributes = [
			$size,
			$maxlength,
			$value,
			$values,
			$class,
			$style,
			$onchange,
			$checked,
		];
	}

}
