<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 6b5d694631b0 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2021-06-28 11:37 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_weTag_textAttribute extends we_weTag_attribute{
	/** @var string */
	protected $type;

	/**
	 * @param string $name
	 * @param boolean $required
	 * @param string $module
	 */
	public function __construct(we_weTag_twbase $tag, string $name, string $default, bool $required = false, string $module = '', string $description = '', string $type = 'text', bool $deprecated = false){
		$this->type = $type;
		parent::__construct($tag, $name, $default, $required, $module, $description, $deprecated);
	}

	function getCodeForTagWizard(we_html_tr $row): void{
		$row->td($this->getLabelCodeForTagWizard(), ['class' => 'attributeName']);
		$row->td(we_html_element::input([
				'name' => $this->Name,
				'id' => $this->getIdName(),
				'value' => $this->Value,
				'class' => 'wetextinput',
				'type' => $this->type,
				'placeholder' => $this->defaultValue,
			]), ['class' => 'attributeField']);
		$row->td('', ['class' => 'attributeButton']);
		$row->td($this->defaultValue, ['class' => 'defaultValue']);
	}

}
