/* global fileSelect, top,WE */

/**
 * webEdition CMS
 *
 * $Rev: 70304633e836 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2021-08-26 11:34 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';
var
	clickCount = 0,
	name_ord = 0,
	type_ord = 0,
	date_ord = 0,
	size_ord = 0;
WE().util.dialogTop(window).metaKeys = {
	ctrl: false,
	shift: false,
	doubleClick: false,
	inputClick: false,
	doubleTout: null
};
var selector = WE().util.getDynamicVar(document, 'loadVarSelectors', 'data-selector');
WE().util.dialogTop(window).allentries = selector.allentries;
function dbFolderClick(id) {
	WE().util.dialogTop(window).metaKeys.doubleTout = setTimeout(function () {
		if (!WE().util.dialogTop(window).metaKeys.doubleClick) {
			doClick(id, 1, 1);
		} else {
			WE().util.dialogTop(window).metaKeys.doubleClick = false;
		}
	}, 300);
	return true;
}

function dbFolderDblClick(id) {
	WE().util.dialogTop(window).metaKeys.doubleClick = true;
	clearTimeout(WE().util.dialogTop(window).metaKeys.doubleTout);
	doClick(id, 1, 1);
	return true;
}

function internalClick(id) {
	if (WE().util.dialogTop(window).fileSelect.click.oldID === id) {
		WE().util.dialogTop(window).metaKeys.doubleTout = setTimeout(function () {
			if (!WE().util.dialogTop(window).metaKeys.doubleClick) {
				clickEditFile(WE().util.dialogTop(window).fileSelect.click.oldID);
			}
		}, 500);
	}
	WE().util.dialogTop(window).fileSelect.click.oldID = id;
	doClick(id, 0, 0);
	return true;
}

function folderClick(id) {
	if (WE().util.dialogTop(window).fileSelect.click.oldID === id) {
		WE().util.dialogTop(window).metaKeys.doubleTout = setTimeout(function () {
			if (!WE().util.dialogTop(window).metaKeys.doubleClick) {
				clickEdit(WE().util.dialogTop(window).fileSelect.click.oldID);
			}
		}, 500);
	}
	WE().util.dialogTop(window).fileSelect.click.oldID = id;
	doSelectFolder(id, 0);
}

function folderDblClick(id) {
	WE().util.dialogTop(window).metaKeys.doubleClick = true;
	clearTimeout(WE().util.dialogTop(window).metaKeys.doubleTout);
	clearTimeout(WE().util.dialogTop(window).metaKeys.doubleTout);
	doClick(id, 1, 0);
	return true;
}

function fileClick(id) {
	if (WE().util.dialogTop(window).fileSelect.click.oldID === id)
		WE().util.dialogTop(window).metaKeys.doubleTout = setTimeout(function () {
			if (!WE().util.dialogTop(window).metaKeys.doubleClick) {
				clickEditFile(WE().util.dialogTop(window).fileSelect.click.oldID);
			}
		}, 500);
	WE().util.dialogTop(window).fileSelect.click.oldID = id;
	doClick(id, 0, 0);
	return true;
}

function doClick(id, ct, indb) {
	if (ct === 1) {
		if (WE().util.dialogTop(window).metaKeys.doubleClick) {
			WE().util.dialogTop(window).fscmd.selectDir(id);
			if (WE().util.dialogTop(window).fileSelect.data.filter !== WE().consts.contentTypes.FOLDER_DOCUMENT) {
				WE().util.dialogTop(window).fscmd.selectFile("");
			}
			window.setTimeout(function () {
				WE().util.dialogTop(window).metaKeys.doubleClick = false;
			}, 400);
		} else {
			if (WE().util.dialogTop(window).fileSelect.data.filter === WE().consts.contentTypes.FOLDER_DOCUMENT && (!indb)) {
				WE().util.dialogTop(window).fscmd.selectFile(id);
			}
		}
		if ((WE().util.dialogTop(window).fileSelect.click.oldID === id) && (!WE().util.dialogTop(window).metaKeys.doubleClick)) {
			clickEdit(id);
		}
	} else {
		WE().util.dialogTop(window).fscmd.selectFile(id);
		WE().util.dialogTop(window).dirsel = 0;
	}
	WE().util.dialogTop(window).WE().util.dialogTop(window).fileSelect.click.oldID = id;
}

function doSelectFolder(entry, indb) {
	switch (WE().util.dialogTop(window).fileSelect.data.filter) {
		case "all_Types":
			if (!WE().util.dialogTop(window).fileSelect.data.browseServer) {
				break;
			}
			/* falls through */
		case "folder":
		case WE().consts.contentTypes.FOLDER_DOCUMENT:
			if (!indb) {
				WE().util.dialogTop(window).fscmd.selectFile(entry);
			}
			WE().util.dialogTop(window).dirsel = 1;
	}
}

function clickEdit(dir) {
	switch (WE().util.dialogTop(window).fileSelect.data.filter) {
		case "folder":
		case WE().consts.contentTypes.FOLDER_DOCUMENT:
			break;
		default:
			setScrollTo();
			WE().util.dialogTop(window).fscmd.drawDir(WE().util.dialogTop(window).fileSelect.data.currentDir, "rename_folder", dir);
	}
}

function clickEditFile(file) {
	setScrollTo();
	WE().util.dialogTop(window).fscmd.drawDir(WE().util.dialogTop(window).fileSelect.data.currentDir, "rename_file", file);
}

function doScrollTo() {
	if (window.parent.scrollToVal) {
		window.scrollTo(0, window.parent.scrollToVal);
		window.parent.scrollToVal = 0;
	}
}

function keypressed(e) {
	if (e.key === 'Enter') { // RETURN KEY => valid for all Browsers
		window.setTimeout(document.we_form.txt.blur, 30);
	}
}

function setScrollTo(no) {
	if (no === undefined) {//assume old templates, go to edit content
		no = WE().layout.weEditorFrameController.getEditorFrame(window.parent.name).getEditorEditPageNr();
	}
	window.parent.scrollToVal[no] = window.pageYOffset;
}

function initSelector(type) {
	document.we_form.elements.txt.focus();
	document.we_form.elements.txt.select();
	if (type === "rename_folder" || type === "rename_file") {
		document.we_form.elements.oldtxt.value = document.we_form.elements.txt.value;
	}
	document.we_form.elements.pat.value = WE().util.dialogTop(window).fileSelect.data.currentDir;
}

function reorder(name) {
	var order = 0;
	switch (name) {
		case "name":
			if (name_ord == 1) {
				order = 10;
				name_ord = 0;
			} else {
				order = 11;
				name_ord = 1;
			}
			break;
		case "type":
			if (type_ord == 1) {
				order = 20;
				type_ord = 0;
			} else {
				order = 21;
				type_ord = 1;
			}
			break;
		case "date":
			if (date_ord == 1) {
				order = 30;
				date_ord = 0;
			} else {
				order = 31;
				date_ord = 1;
			}
			break;
		case "size":
			if (size_ord == 1) {
				order = 40;
				size_ord = 0;
			} else {
				order = 41;
				size_ord = 1;
			}
			break;
	}
	WE().util.dialogTop(window).fscmd.reorderDir(WE().util.dialogTop(window).fileSelect.data.currentDir, order);
}
